import numpy as np
from typing import List
from aiwolf import Agent, Role, Talk


village_size = 5

talk_dict = {v: i for i, v in enumerate([
    'Over', 'VOTE Agent[00]', 'ESTIMATE Agent[00] WEREWOLF',
    'REQUEST ANY (VOTE Agent[00])', 'Skip',
    'IDENTIFIED Agent[00] WEREWOLF',
    'REQUEST ANY (DIVINATION Agent[00])', 'Agent[00] VOTE Agent[00]',
    'DIVINED Agent[00] HUMAN', 'REQUEST ANY (COMINGOUT ANY ANY)',
    'COMINGOUT Agent[00] SEER', 'DIVINED Agent[00] WEREWOLF',
    'IDENTIFIED Agent[00] HUMAN', 'COMINGOUT Agent[00] MEDIUM',
    'Agent[00] ESTIMATE Agent[00] WEREWOLF',
    'COMINGOUT Agent[00] BODYGUARD', 'ESTIMATE Agent[00] POSSESSED',
    'ESTIMATE Agent[00] VILLAGER', 'GUARDED Agent[00]',
    'Agent[00] REQUEST ANY (DIVINATION Agent[00])',
    'AND (GUARDED Agent[00]) (NOT (ESTIMATE Agent[00] WEREWOLF))',
    'COMINGOUT Agent[00] VILLAGER',
    'Agent[00] DIVINED Agent[00] HUMAN',
    'Agent[00] ESTIMATE Agent[00] POSSESSED',
    'Agent[00] COMINGOUT Agent[00] SEER',
    'Agent[00] DIVINED Agent[00] WEREWOLF',
    'Agent[00] COMINGOUT Agent[00] MEDIUM',
    'Agent[00] IDENTIFIED Agent[00] HUMAN',
    'Agent[00] IDENTIFIED Agent[00] WEREWOLF',
    'COMINGOUT Agent[00] POSSESSED',
    'Agent[00] REQUEST ANY (VOTE Agent[00])',
    'COMINGOUT Agent[00] WEREWOLF',
])
}

role_index = {
    "SEER": 1,
    "MEDIUM": 2,
    "BODYGUARD": 3,
    "VILLAGER": 4,
    "POSSESSED": 5,
    "WEREWOLF": 6
}

agent_name_dict = {v: i for i, v in enumerate([
    'HO',
    'Howls',
    'Howls03',
    'Howls_02',
    'Lunatic',
    'MayQueen',
    'TOT',
    'abe',
    'cash',
    'ddhb',
    'gotsumori',
    'inaba',
    'ioh',
    'mikami',
    'pronto'
])}

clf_coef = np.array([
np.array([ 0.40771178, -0.08195505, -0.06178602, -0.41569228,  1.95966923,
0.        ,  0.        , -0.29171108,  0.89936745, -0.0532664 ,
1.18775307, -0.22184332,  0.        ,  0.        , -0.10151765,
0.        ,  1.31845327,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.14937638, -0.12940792, -0.22380272,
-0.08417643,  0.        ,  0.        ,  0.        , -0.00817632,
-0.08789967, -0.48526175,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  1.11577849,  0.73527531, -1.12206772, -1.98370199,
2.81187196,  0.        ,  1.14231534, -1.07522625,  0.        ,
-0.49574852,  0.        ,  0.        ,  0.        ,  0.        ,
-0.05928095,  0.        ,  0.        ,  0.        ,  0.        ,
-0.05928095,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.32436055,  0.        , -1.0105336 ,  0.17579763, -0.71190535,
0.91546544, -0.95934961,  1.53065334,  0.        ,  2.03934056,
-0.24017809,  0.88298575, -0.20692813,  0.13302535, -0.12045878,
0.        ,  0.        , -0.24096046,  0.        ,  0.        ,
0.        ,  0.        , -0.24096046,  0.        ,  0.        ,
-0.13388664,  0.        , -0.16493344, -0.06085353,  0.        ,
0.        ,  0.        , -0.82896593,  0.        , -0.63550603,
0.37426678,  0.02459373,  1.52900735, -1.39198514,  1.40087519,
0.        ,  0.        , -0.3355484 ,  0.56986511, -0.01656926,
0.80399238, -0.18698391,  0.        ,  0.        , -0.3355484 ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.06872037,  0.        , -0.10166325,
-0.07089813,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.39740936]),
np.array([-1.08413291,  1.28753613,  2.227313  ,  1.59172424, -0.97628496,
0.        ,  0.        , -0.04538047, -0.25182666, -0.3027052 ,
0.52836303,  0.66036919,  0.        ,  0.        , -0.01509275,
0.        , -0.43083305,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.02883307, -0.08544082, -0.0342531 ,
-0.00787689,  0.        ,  0.        ,  0.        , -0.00349798,
-0.00841061, -0.19923326,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -1.05085354,  1.49660501,  2.45620553,  2.7827749 ,
-0.27463343,  0.        , -0.88290346, -0.0399348 ,  0.        ,
-1.76362356,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00415719,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00415719,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.09924109,  0.        , -0.52342655, -0.39392226,  0.59967094,
1.97433597,  1.76475103, -1.22004233,  0.        , -0.64358224,
-0.06750428, -0.15993016,  2.54881017, -0.59034867,  0.4893825 ,
0.        ,  0.        , -0.06810309,  0.        ,  0.        ,
0.        ,  0.        , -0.06810309,  0.        ,  0.        ,
-0.03419166,  0.        , -0.04115153, -0.01460412,  0.        ,
0.        ,  0.        , -0.1452781 ,  0.        ,  0.80260067,
-0.99350803,  1.17112389,  2.29353038,  1.97208667, -1.12843332,
0.        ,  0.        , -0.04424315,  1.2705166 , -0.03876904,
0.32633058, -0.25723713,  0.        ,  0.        , -0.04424315,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.01092906,  0.        , -0.01369958,
-0.00899542,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.22745692]),
np.array([-1.0560759 ,  1.26547972,  2.42073537,  1.85833341, -0.54677982,
0.        ,  0.        , -0.0388857 , -0.38567204, -0.07842737,
-0.2818456 , -0.34012422,  0.        ,  0.        , -0.01290381,
0.        , -0.3021993 ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.02462482, -0.07172385, -0.02923456,
-0.00680039,  0.        ,  0.        ,  0.        , -0.00307345,
-0.00728126,  1.0869659 ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -1.88980018,  1.66189211,  2.6508714 ,  2.8838553 ,
-1.25109552,  0.        , -0.43740231, -0.03632801,  0.        ,
-0.93042847,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00365339,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00365339,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.05328312,  0.        , -0.10704158, -0.40435299,  0.70286765,
1.97032827,  1.83806143, -0.72298993,  0.        , -0.35968866,
-0.05534386, -0.15414078,  1.76003099,  0.59054951,  0.11981876,
0.        ,  0.        , -0.05580914,  0.        ,  0.        ,
0.        ,  0.        , -0.05580914,  0.        ,  0.        ,
-0.02798921,  0.        , -0.03347025, -0.01192926,  0.        ,
0.        ,  0.        , -0.09716578,  0.        , -0.33481861,
-1.15935924,  0.97984972,  2.37696968,  2.06784618, -0.75110962,
0.        ,  0.        , -0.03910686, -0.56024279, -0.01115975,
-0.72845212, -0.39141949,  0.        ,  0.        , -0.03910686,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.0096438 ,  0.        , -0.01200776,
-0.00790947,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.76880098]),
np.array([ 1.16335155, -3.50048057, -1.27633408, -1.33145372,  1.21079872,
0.        ,  0.        , -0.84050716, -1.18094789, -0.02960995,
-2.06945243, -1.0719391 ,  0.        ,  0.        , -0.19677017,
0.        , -0.4623796 ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.34742337, -0.15471558, -0.47950072,
-0.15983803,  0.        ,  0.        ,  0.        , -0.01058645,
-0.19651153, -0.03659763,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  1.84587959, -9.04238273, -2.08220459, -1.27158886,
2.5675135 ,  0.        , -0.57219584, -2.79198174,  0.        ,
-0.18499446,  0.        ,  0.        ,  0.        ,  0.        ,
-0.07681338,  0.        ,  0.        ,  0.        ,  0.        ,
-0.07681338,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.10615904,  0.        , -0.08050874,  1.15246068, -3.90426338,
-1.79922519, -0.77470621,  1.38219639,  0.        , -1.00532802,
-0.51376513, -1.29900463, -0.145322  , -1.75561987, -0.79257025,
0.        ,  0.        , -0.51462876,  0.        ,  0.        ,
0.        ,  0.        , -0.51462876,  0.        ,  0.        ,
-0.27866629,  0.        , -0.36432716, -0.18151416,  0.        ,
0.        ,  0.        , -0.22850828,  0.        , -0.09880306,
1.1675256 , -4.92592414, -2.99763536, -0.82442496,  1.21849385,
0.        ,  0.        , -0.97287937, -0.29625849, -0.01169537,
-0.5670669 , -0.50001072,  0.        ,  0.        , -0.97287937,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.09573945,  0.        , -0.13219843,
-0.09920557,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.33407799]),
np.array([ 4.22497405e-01,  1.23145668e+00, -2.23720173e+00, -2.14569360e+00,
-3.55019471e+00,  0.00000000e+00,  0.00000000e+00, -1.14676543e-01,
-8.59122057e-01, -2.64669778e-01,  2.83110380e-01,  1.52420870e+00,
0.00000000e+00,  0.00000000e+00, -4.02742023e-02,  0.00000000e+00,
-5.77826415e-01,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -6.81460108e-02, -1.39192134e-01,
-8.69362857e-02, -2.45367694e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  5.80246442e-01, -2.58368279e-02, -3.10434673e-02,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
-9.09177225e-01,  2.00057056e+00,  1.01067366e+00,  1.57577688e+00,
-4.89824579e+00,  0.00000000e+00, -6.71488920e-01, -4.51285652e-02,
0.00000000e+00,  4.84888464e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -4.46154280e-03,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -4.46154280e-03,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  5.58191170e-01,  0.00000000e+00, -5.92889078e-01,
9.26892938e-01,  1.03049777e+00, -2.53790319e+00, -1.79248068e+00,
-2.42900008e+00,  0.00000000e+00, -8.76108909e-01, -1.48987811e-01,
-1.24446109e+00, -5.34293810e-01,  4.41269873e-01,  1.87399009e-01,
0.00000000e+00,  0.00000000e+00, -1.49934182e-01,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -1.49934182e-01,
0.00000000e+00,  0.00000000e+00, -8.16710295e-02,  0.00000000e+00,
-9.63438771e-02, -3.65394231e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  1.83349155e+00,  0.00000000e+00, -1.37216614e-01,
9.56079199e-01,  5.67949041e-01, -2.39802875e+00, -1.61574822e+00,
-3.17653619e+00,  0.00000000e+00,  0.00000000e+00, -1.03956975e-01,
-4.03947159e-01, -2.83495850e-02,  1.32812705e+00,  2.85899567e+00,
0.00000000e+00,  0.00000000e+00, -1.03956975e-01,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -2.29967881e-02,  0.00000000e+00,
-2.93697170e-02, -1.95669821e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -3.33724446e-01]),
np.array([ 1.16343432e+00, -3.54697668e-01, -1.88778436e+00, -1.73927531e+00,
1.35201553e+00,  0.00000000e+00,  0.00000000e+00, -9.28772769e-01,
-2.10150634e+00, -3.14352796e-02, -3.32036907e+00, -1.54699142e+00,
0.00000000e+00,  0.00000000e+00, -2.23061362e-01,  0.00000000e+00,
-5.07904299e-01,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -3.88626305e-01, -1.69952479e-01,
-5.31419204e-01, -1.77449299e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -4.37601624e-02, -2.20906221e-01, -8.77918108e-02,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
-2.36377373e+00,  4.01350607e+00, -4.46135932e+00, -3.64234185e+00,
-2.60451671e+00,  0.00000000e+00, -4.81539650e-01, -3.93293215e-02,
0.00000000e+00, -1.01784562e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -3.87252727e-03,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -3.87252727e-03,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -1.58626881e-01,  0.00000000e+00, -3.49032481e-02,
4.13681695e-01,  1.78467412e+00, -2.23193550e+00, -1.95155351e+00,
-6.85498761e-01,  0.00000000e+00, -4.39799217e-01, -6.11802075e-02,
5.73089582e-01, -4.15829666e-01,  3.20498522e-01, -1.13560443e+00,
0.00000000e+00,  0.00000000e+00, -6.16927185e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -6.16927185e-02,
0.00000000e+00,  0.00000000e+00, -3.10814376e-02,  0.00000000e+00,
-3.70655678e-02, -1.32535725e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  1.07995933e+00,  0.00000000e+00, -2.52296187e-01,
4.99058318e-01,  1.88927658e+00, -4.53143708e+00, -2.65842572e+00,
2.06124025e+00,  0.00000000e+00,  0.00000000e+00, -7.52048075e-02,
-6.39863495e-01, -8.33473632e-02,  3.32769988e-01,  3.22957382e-01,
0.00000000e+00,  0.00000000e+00, -7.52048075e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -1.64398986e-02,  0.00000000e+00,
-2.29219110e-02, -1.53594393e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -2.57009894e-01]),
np.array([ 6.11699601e-01, -2.36149405e+00, -1.03011248e+00, -1.13865537e+00,
1.11901331e+00,  0.00000000e+00,  0.00000000e+00,  3.48605249e+00,
-7.16775786e-01, -2.71383122e-02, -1.44347239e+00, -8.11189262e-01,
0.00000000e+00,  0.00000000e+00,  1.00756941e+00,  0.00000000e+00,
-3.69239272e-01,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  1.66945356e+00,  1.67698513e+00,
2.31434765e+00,  7.77634823e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -3.96243405e-03,  8.80074995e-01, -1.85083815e-02,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
1.46490202e+00, -6.02191522e+00, -1.96877330e+00, -1.24634323e+00,
1.28199423e+00,  0.00000000e+00, -4.86069796e-01,  6.47815258e+00,
0.00000000e+00, -1.81189981e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  3.35805829e-01,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  3.35805829e-01,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -9.69491245e-02,  0.00000000e+00, -4.22917466e-02,
4.06110591e-01, -2.48427429e+00, -1.32735102e+00, -6.61229615e-01,
1.31510707e+00,  0.00000000e+00, -6.70063977e-01,  2.05834084e+00,
-5.43225942e-01, -1.19167270e-01, -8.79644024e-01, -4.95835031e-01,
0.00000000e+00,  0.00000000e+00,  2.06777167e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  2.06777167e+00,
0.00000000e+00,  0.00000000e+00,  1.10752746e+00,  0.00000000e+00,
1.38142970e+00,  5.50833675e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -1.23486435e-01,  0.00000000e+00, -7.52742687e-02,
5.46302583e-01, -2.99047435e+00, -2.02744519e+00, -7.98927374e-01,
1.32183120e+00,  0.00000000e+00,  0.00000000e+00,  3.06700675e+00,
-2.84446463e-01, -1.17160645e-02, -5.15953543e-01, -4.10828693e-01,
0.00000000e+00,  0.00000000e+00,  3.06700675e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  5.20135949e-01,  0.00000000e+00,
7.40688771e-01,  5.21231065e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -2.52862727e-01]),
np.array([ 0.26793858, -0.04933423,  0.01835634, -0.46290791,  2.19033783,
0.        ,  0.        , -0.31182876,  1.16439835, -0.05443917,
0.51368494,  0.11395064,  0.        ,  0.        , -0.10947125,
0.        ,  1.35889184,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.15789007, -0.13597555, -0.24196201,
-0.09367879,  0.        ,  0.        ,  0.        , -0.00696577,
-0.09739976, -0.43888109,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.71363639,  1.07534949, -0.69587415, -2.71083989,
2.71299187,  0.        ,  3.36416405, -0.1267695 ,  0.        ,
-0.56496963,  0.        ,  0.        ,  0.        ,  0.        ,
-0.02040295,  0.        ,  0.        ,  0.        ,  0.        ,
-0.02040295,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
1.47878485,  0.        , -0.15987347, -0.12324795, -0.68891837,
0.55948398, -0.99364164,  1.1683173 ,  0.        ,  1.71706931,
-0.17484935,  0.67116276, -0.21160162,  2.36887174, -0.07388945,
0.        ,  0.        , -0.17563587,  0.        ,  0.        ,
0.        ,  0.        , -0.17563587,  0.        ,  0.        ,
-0.09390707,  0.        , -0.11686464, -0.04170399,  0.        ,
0.        ,  0.        ,  1.93554521,  0.        , -0.76239174,
0.23123292, -0.2918982 ,  1.25115571, -1.20294615,  1.97959211,
0.        ,  0.        , -0.29588468, -1.11660334, -0.01485292,
-1.81508553, -1.2844466 ,  0.        ,  0.        , -0.29588468,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.05382345,  0.        , -0.08525961,
-0.05887647,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  2.91063059]),
np.array([ 1.7551981 , -3.1461763 , -1.8247096 , -1.6298665 , -5.70643489,
0.        ,  0.        , -0.23045865,  2.16952005, -0.055992  ,
2.03375232, -0.24914607,  0.        ,  0.        , -0.07326528,
0.        , -0.84753557,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.13247969, -0.22024868, -0.16100294,
-0.04468196,  0.        ,  0.        ,  0.        , -0.47151508,
-0.04957395, -0.04260203,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  2.8603784 , -1.56229544, -3.36222954, -2.21769118,
-9.12874694,  0.        , -0.83288714, -0.59640446,  0.        ,
-0.4582133 ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.03502817,  0.        ,  0.        ,  0.        ,  0.        ,
-0.03502817,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.33485589,  0.        , -0.07157628,  0.88233643,  1.73329554,
-3.14931967, -2.84035069, -2.54863787,  0.        , -0.77404594,
-0.09107149,  1.34993014, -0.5100664 , -0.64160518, -0.26508246,
0.        ,  0.        , -0.09176163,  0.        ,  0.        ,
0.        ,  0.        , -0.09176163,  0.        ,  0.        ,
-0.04801027,  0.        , -0.05560481, -0.0208694 ,  0.        ,
0.        ,  0.        , -3.36938292,  0.        , -0.38618534,
1.90851654, -0.82413891, -2.76708706, -1.19657871, -6.02692815,
0.        ,  0.        , -0.37159815, -0.35268765, -0.01464903,
-1.27960918, -1.47118825,  0.        ,  0.        , -0.37159815,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.06204681,  0.        , -0.06870928,
-0.04970156,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.63203746]),
np.array([-1.24598203e+00,  1.74175382e+00, -2.37674494e+00,  1.67854502e+00,
2.51020615e+00,  0.00000000e+00,  0.00000000e+00, -5.04124458e-02,
-3.94821628e-01, -4.35196058e-01, -4.49273690e-01,  7.33635550e-02,
0.00000000e+00,  0.00000000e+00, -1.71697226e-02,  0.00000000e+00,
-4.05245945e-01,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -3.09149919e-02, -8.33699096e-02,
-3.78708210e-02, -9.60424999e-03,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -3.64209056e-03, -1.02289704e-02,  7.98874503e-03,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
-5.88364540e-01,  6.82929966e-01,  1.45087931e+00,  1.64130020e+00,
3.87112095e+00,  0.00000000e+00, -1.94395180e+00, -7.63894469e-02,
0.00000000e+00,  4.08231947e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -1.99063143e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -1.99063143e-02,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -9.62011401e-02,  0.00000000e+00,  2.15601253e-01,
-1.70711269e+00,  1.13352933e+00, -2.41329278e+00,  2.28263410e+00,
2.57506612e+00,  0.00000000e+00, -4.51024035e-01, -8.46916582e-02,
-6.55514305e-01, -6.47863825e-01, -5.06571053e-01,  3.39852046e-01,
0.00000000e+00,  0.00000000e+00, -8.52384454e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -8.52384454e-02,
0.00000000e+00,  0.00000000e+00, -4.24579615e-02,  0.00000000e+00,
-5.14344091e-02, -1.80823240e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -1.37710271e-01,  0.00000000e+00,  9.14879193e-02,
-1.02987366e+00,  1.12901131e+00, -2.34873080e+00,  2.11974478e+00,
2.60331567e+00,  0.00000000e+00,  0.00000000e+00, -5.41420239e-02,
-1.32212246e-01,  3.93441197e-01,  2.20449709e-01,  4.45765398e-01,
0.00000000e+00,  0.00000000e+00, -5.41420239e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -1.32182713e-02,  0.00000000e+00,
-1.91675763e-02, -1.34657406e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -8.08920397e-02]),
np.array([-0.92128896,  1.31359675,  2.13862941,  1.5160125 , -1.21746722,
0.        ,  0.        , -0.04416959, -0.07037218,  3.14255256,
0.21382691,  0.46282126,  0.        ,  0.        , -0.01468567,
0.        , -0.42621161,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.02806066, -0.08321327, -0.03332895,
-0.00766093,  0.        ,  0.        ,  0.        , -0.00342809,
-0.00818209,  0.12165364,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -1.1965355 ,  1.5282595 ,  2.44569061,  2.70178351,
-0.37126928,  0.        , -0.82759343, -0.03926107,  0.        ,
1.71291424,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00400992,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00400992,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.1111743 ,  0.        ,  2.25754   , -0.45416251,  0.60810008,
1.98218437,  1.82788078, -1.18822689,  0.        , -0.62361795,
-0.06566069, -0.0460867 ,  1.88317846,  0.09353835,  0.63665662,
0.        ,  0.        , -0.06624198,  0.        ,  0.        ,
0.        ,  0.        , -0.06624198,  0.        ,  0.        ,
-0.03322546,  0.        , -0.03999016, -0.01418869,  0.        ,
0.        ,  0.        , -0.13583418,  0.        ,  0.85629122,
-1.20387239,  1.26080778,  2.28142342,  2.02691153, -1.1651215 ,
0.        ,  0.        , -0.04320504,  1.34833917, -0.04231339,
0.71740991, -0.34855257,  0.        ,  0.        , -0.04320504,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.01067007,  0.        , -0.01336396,
-0.0087786 ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.26772053]),
np.array([ 0.37243616, -0.16738133, -0.11730356, -0.49189651,  1.97150849,
0.        ,  0.        , -0.21862242,  1.18743067, -0.04624962,
0.9310938 , -0.12199625,  0.        ,  0.        , -0.07629209,
0.        ,  1.27982048,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.11284854, -0.10855503, -0.1703358 ,
-0.06352513,  0.        ,  0.        ,  0.        , -0.00620019,
-0.06581248, -0.34994441,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  1.131242  , -0.16177261, -0.2177676 , -2.31634829,
2.75467744,  0.        ,  3.31359621, -0.54915199,  0.        ,
-0.35522095,  0.        ,  0.        ,  0.        ,  0.        ,
-0.03975877,  0.        ,  0.        ,  0.        ,  0.        ,
-0.03975877,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.2344778 ,  0.        , -0.86119628,  0.18232829, -0.52250093,
0.85596328, -0.8487744 ,  1.67309157,  0.        ,  1.84888912,
-0.20246435,  0.13465053, -0.18861238, -0.56986346,  0.7331408 ,
0.        ,  0.        , -0.20319897,  0.        ,  0.        ,
0.        ,  0.        , -0.20319897,  0.        ,  0.        ,
-0.11361647,  0.        , -0.14688522, -0.05320428,  0.        ,
0.        ,  0.        , -0.50227096,  0.        , -0.40776176,
0.23205159, -0.24370876,  1.32415418, -1.08766428,  2.03220646,
0.        ,  0.        , -0.32198922,  0.62760723, -0.01584903,
0.12650327, -0.18588339,  0.        ,  0.        , -0.32198922,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.07058353,  0.        , -0.11756278,
-0.08275387,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -0.32969081]),
np.array([-1.31915486,  1.36943025,  2.26670707,  1.63826468, -0.98569858,
0.        ,  0.        , -0.04488049, -0.08937338, -0.39400365,
0.52870185,  0.90489044,  0.        ,  0.        , -0.01491358,
0.        , -0.42804279,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.02852506, -0.08456042, -0.03386553,
-0.00778141,  0.        ,  0.        ,  0.        , -0.00349072,
-0.00831178, -0.58583259,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        , -1.12565381,  1.48603945,  2.52872695,  2.80537141,
-0.33733517,  0.        , -0.8443328 , -0.03984563,  0.        ,
-1.69091476,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00413632,  0.        ,  0.        ,  0.        ,  0.        ,
-0.00413632,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
-0.0984377 ,  0.        , -0.56961943, -0.49389173,  0.6147744 ,
2.06080387,  1.82181264, -1.14621175,  0.        , -0.64133966,
-0.06608125, -0.0056669 ,  2.62974133, -0.39354272,  0.02823071,
0.        ,  0.        , -0.06666547,  0.        ,  0.        ,
0.        ,  0.        , -0.06666547,  0.        ,  0.        ,
-0.03344039,  0.        , -0.0402133 , -0.01427597,  0.        ,
0.        ,  0.        , -0.14365509,  0.        ,  0.62294224,
-1.08625098,  1.18618778,  2.28041533,  2.00006483, -1.03117099,
0.        ,  0.        , -0.04412827,  1.31478921, -0.04225518,
0.76801948, -0.3400385 ,  0.        ,  0.        , -0.04412827,
0.        ,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.        , -0.01089964,  0.        , -0.01365591,
-0.00896817,  0.        ,  0.        ,  0.        ,  0.        ,
0.        ,  0.0719441 ]),
np.array([ 4.20569701e-01,  1.71885928e-01, -4.12898624e-01, -5.38819277e-01,
1.66270781e+00,  0.00000000e+00,  0.00000000e+00, -2.80485293e-01,
1.10855340e+00, -5.29778538e-02,  8.44025827e-01, -2.09733275e-01,
0.00000000e+00,  0.00000000e+00, -9.70836222e-02,  0.00000000e+00,
1.21521571e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -1.42970406e-01, -1.25782724e-01,
-2.16678236e-01, -8.21506018e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -8.46987490e-03, -8.53129806e-02,  1.33627706e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
1.00929492e+00,  6.24276349e-01, -1.10193604e+00, -1.78459096e+00,
3.00757753e+00,  0.00000000e+00,  9.79510199e-01, -9.82675161e-01,
0.00000000e+00, -4.03383681e-01,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -5.61957884e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -5.61957884e-02,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -2.29560194e-01,  0.00000000e+00,  2.08718510e+00,
-2.08813582e-03, -7.40260076e-01,  6.95870846e-01, -9.18779743e-01,
1.75204790e+00,  0.00000000e+00,  1.72697966e+00, -2.20859508e-01,
9.20341329e-01, -1.89020651e-01,  5.55947229e-01, -2.02158140e-01,
0.00000000e+00,  0.00000000e+00, -2.21620486e-01,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -2.21620486e-01,
0.00000000e+00,  0.00000000e+00, -1.22106729e-01,  0.00000000e+00,
-1.53168466e-01, -5.56097724e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  1.00906301e+00,  0.00000000e+00,  1.54725719e+00,
3.75482285e-01, -9.41610159e-02,  1.45049121e+00, -1.34024693e+00,
1.30594399e+00,  0.00000000e+00,  0.00000000e+00, -3.19927867e-01,
9.40274029e-01, -1.61712679e-02,  3.10070991e-01,  2.06009943e-01,
0.00000000e+00,  0.00000000e+00, -3.19927867e-01,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -6.32701507e-02,  0.00000000e+00,
-9.71512199e-02, -6.75813217e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -3.58737538e-01]),
np.array([-9.58202533e-01,  1.28037993e+00,  2.15313420e+00,  1.61138064e+00,
-9.93396892e-01,  0.00000000e+00,  0.00000000e+00, -4.52611212e-02,
-4.78851978e-01, -1.31644191e+00,  5.00101058e-01,  8.33359123e-01,
0.00000000e+00,  0.00000000e+00, -1.50682399e-02,  0.00000000e+00,
-4.14963439e-01,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -2.87341820e-02, -8.48467606e-02,
-3.41567699e-02, -7.87393986e-03,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -3.47782447e-03, -8.40687611e-03, -2.77188921e-01,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
-1.01695329e+00,  1.48366218e+00,  2.46916482e+00,  2.78258404e+00,
-1.41904642e-01,  0.00000000e+00, -8.19220665e-01, -3.97266298e-02,
0.00000000e+00, -2.59758542e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -4.12861371e-03,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -4.12861371e-03,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -9.36491872e-02,  0.00000000e+00, -5.06466342e-01,
-5.60829984e-01,  8.44712581e-01,  2.44459132e+00,  2.20572612e+00,
-1.45587208e+00,  0.00000000e+00, -8.47680054e-01, -6.57031688e-02,
-4.24129596e-01, -5.65305518e+00,  8.33494402e-01,  5.51118108e-01,
0.00000000e+00,  0.00000000e+00, -6.62804480e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -6.62804480e-02,
0.00000000e+00,  0.00000000e+00, -3.32768282e-02,  0.00000000e+00,
-3.99768655e-02, -1.42051840e-02,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00, -1.45801150e-01,  0.00000000e+00, -8.30325638e-01,
-8.17651513e-01,  1.16150555e+00,  2.28321697e+00,  1.93029349e+00,
-6.44198944e-01,  0.00000000e+00,  0.00000000e+00, -4.51919317e-02,
-2.28512972e+00, -4.57439310e-02, -2.75060773e-02,  1.54286087e+00,
0.00000000e+00,  0.00000000e+00, -4.51919317e-02,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00, -1.11546673e-02,  0.00000000e+00,
-1.39577744e-02, -9.17030651e-03,  0.00000000e+00,  0.00000000e+00,
0.00000000e+00,  0.00000000e+00,  0.00000000e+00, -2.79755952e-01])
])
clf_intercept = np.array([
    -0.12952013,  0.78557866, -1.11103714, -1.06030157,  1.09765624,
    -1.2704501 ,  0.11869429,  0.58070322, -0.62511336, -0.12732856,
    0.34855501, -0.06750369,  0.49779497,  0.42344558,  0.53882657
])


def mask(text_):
    res = ""
    for i, c in enumerate(text_):
        if res[-6:] == "Agent[":
            res += "0"
        elif res[-7:] == "Agent[0":
            res += "0"
        else:
            res += c
    return res


class AgentEstimator05:

    def __init__(self):
        self.agent_prob = np.ones((village_size, 15), dtype=np.float32) / 15
        self.count = 1

    def update(self, agent_map, talk_list: List[Talk]):
        k: Agent
        v: Role
        # for k in agent_map.keys():
        #     v = agent_map[k]
        #     print(k.agent_idx, v.name)
        # print([(talk.day, talk.idx, talk.agent.agent_idx, talk.text) for talk in talk_list])
        x = np.zeros((village_size, 32 * 6), dtype=np.float32)
        for talk in talk_list:
            i = talk.agent.agent_idx - 1
            talk_mod = mask(talk.text)
            if talk_mod in talk_dict.keys():
                j = talk_dict[talk_mod]
                v = agent_map[talk.agent]
                j += 32 * (role_index[v.name] - 1)
                x[i, j] += 1
        pred_log = np.matmul(x, np.transpose(clf_coef)) + clf_intercept
        pred = np.exp(pred_log) / np.exp(pred_log).sum(axis=1, keepdims=True)
        self.agent_prob = self.agent_prob * self.count + pred
        self.agent_prob /= (self.count + 1)
        self.agent_prob /= self.agent_prob.sum(axis=1, keepdims=True)
        self.count += 1
        # print(self.agent_prob)
